; Displaying an icon from binary data - Version 1.2
; Example built with Solar Assembler version 0.35.01

include Displayicon.inc

section "code"  class_code
section "data"  class_data
section "idata" class_imports

include kernel32.inc
include user32.inc
include gdi32.inc

.data

DialogBox:
EMIT_RSRC DIALOGBOX

Icon:
INCBIN Smiley.ico

hInstance       dd ?
hBrush          dd ?
hIcon           dd ?
ps              PAINTSTRUCT ?

.entry start

.code

start:

    invoke  GetModuleHandle,0
    mov     [hInstance],eax
    invoke  DialogBoxIndirectParam,[hInstance],DialogBox,0,DlgProc,0
    invoke  ExitProcess,eax

PROC DlgProc
ARG hWnd,uMsg,wParam,lParam

LOCAL hDC
	
    .IF [uMsg] == WM_CTLCOLORDLG
        invoke  SetBkColor,[wParam],WHITE
        invoke  CreateSolidBrush,WHITE
        mov     [hBrush],eax
        ret

    .ELSEIF [uMsg] == WM_INITDIALOG
        mov     edx,Icon
        mov     eax,[edx+ICONDIR.idEntries.dwImageOffset]
        add     eax,edx
        invoke  CreateIconFromResource,eax,[edx+ICONDIR.idEntries.dwBytesInRes],\
                TRUE,ICON_VERSION_NUMBER
        mov     [hIcon],eax
		
    .ELSEIF [uMsg] == WM_PAINT
        invoke  BeginPaint,[hWnd],ps
        mov     [hDC],eax
        invoke  DrawIcon,[hDC],100,100,[hIcon]
        invoke  EndPaint,[hWnd],ps

    .ELSEIF [uMsg] == WM_CLOSE
        invoke  DeleteObject,[hBrush]
        invoke  EndDialog,[hWnd],0

    .ELSE
        xor     eax,eax
        ret

    .ENDIF

    mov     eax,TRUE
    ret
    
ENDP

