; DLL to Solar Assembler include file converter
; Version 1.1 by Vortex
; Assembled with Solar Assembler version 0.35.01

section "code"  class_code
section "data"  class_data
section "data?" class_bss
section "idata" class_imports


include dll2solinc.inc

.data
welcome_msg     db 'DLL to Solar Assembler include file converter',13,10
                db 'Version 1.1 by Vortex',13,10,13,10
                db 'Usage : dll2solinc dllfile.dll',13,10,0
errmsg1         db 'memory allocation failure',0
errmsg2         db 'dll without file extension',0
errmsg3         db 'dll not found or invalid dll',0
errmsg4         db 'unable to write the include file',0
template1       db 'import_dll %',13,10,13,10,0
template2       db 9,'import_func %',13,10,0
template3       db ' alias %',13,10,0

.data?
pCmdLineParam   rb 512
buffer2         rb 256
FilePart        dd ?

.entry start

.code

start:

    invoke  mainCRTStartup
    invoke  ExitProcess,0

PROC main

USES esi,edi,ebx
ARG argc,argv

LOCAL hDLL,NameNumb,DllName,size1
LOCAL hMem,hMem2,FileExtension,hInc

    cmp     [argc],2
    je      l0
    invoke  StdOut,welcome_msg
    ret
l0:
    invoke  VirtualAlloc,0,1024*1024,MEM_COMMIT,PAGE_EXECUTE_READWRITE
    test    eax,eax                     ; allocate memory to create the include file
    jnz     l1
    invoke  StdOut,errmsg1
    ret
l1:
    mov     [hMem],eax
    mov     [hMem2],eax
    mov     edx,[argv]
    mov     eax,DWORD PTR [edx+4]       ; get the command-line parameter indicating the DLL
    mov     [DllName],eax
    invoke  LoadLibrary,eax
    test    eax,eax
    jnz     l2
    invoke  StdOut,errmsg3
    jmp     free_memory2
l2:
    mov     [hDLL],eax
    mov     edi,eax
    add     edi,[edi + IMAGE_DOS_HEADER.e_lfanew]
    mov     edi,[edi + IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.VirtualAddress]
    add     edi,eax
    push    [edi + IMAGE_EXPORT_DIRECTORY.NumberOfNames]
    pop     [NameNumb]                  ; get the number of exported functions
    mov     esi,[edi + IMAGE_EXPORT_DIRECTORY.AddressOfNames]
    add     esi,eax
    invoke  GetFullPathName,[DllName],256,buffer2,FilePart
    mov     ebx,[FilePart]
    invoke  GetFileExtension,ebx        ; get the file extension
    cmp     ebx,eax
    jne     l3
    invoke  StdOut,errmsg2
    jmp     free_memory    
l3:    
    inc     eax
    push    eax
    pop     [FileExtension]
    invoke	wsp,[hMem],template1,[FilePart]
    add     esp,3*4
    add     [hMem],eax

read_symbol:

    mov     edi,DWORD PTR [esi]
    add     edi,[hDLL]
    cmp     BYTE PTR [edi],'?'          ; skip symbols with leading ?
    je      next_symbol
    cmp     [NameNumb],1
    je      process_symbol
    mov     ebx,DWORD PTR [esi+4]       ; get the name of the next symbol
    add     ebx,[hDLL]
    invoke  StrLen,ebx
    lea     ecx,[ebx+eax]    
    sub     ecx,1
    cmp     BYTE PTR [ecx],65           ; check if the symbol is terminating with A
    jne     process_symbol
    sub     eax,2

cmp_strings:

    mov     cl,BYTE PTR [edi+eax]       ; compare the two consecutive strings
    cmp     cl,BYTE PTR [ebx+eax]       ; to determine if they are pointing the same function
    jne     process_symbol
    sub     eax,1
    jnz     cmp_strings
    mov     edi,ebx
    add     esi,4
    dec     [NameNumb]
    
process_symbol:
                
    invoke  wsp,[hMem],template2,edi    ; simple wsprintf emulator
    add     esp,3*4
    add     [hMem],eax
    mov     edx,[hMem]
    lea     ebx,[edx-3]
    cmp     BYTE PTR [ebx],65           ; does the function require an alias?
    jne     next_symbol
    invoke  wsp,ebx,template3,edi
    add     esp,3*4
    sub     eax,3
    add     [hMem],eax

next_symbol:

    add     esi,4
    dec     [NameNumb]
    jnz     read_symbol
    
    mov     eax,[FileExtension]
    mov     DWORD PTR [eax],'cni'       ; ready to create the include file

    invoke  CreateFile,[FilePart],GENERIC_WRITE,\
            0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
    cmp     eax,INVALID_HANDLE_VALUE
    jne     write_file
    invoke  StdOut,errmsg4
    jmp     free_memory            

write_file:

    mov     [hInc],eax
    lea     ecx,[size1]
    mov     edx,[hMem]
    sub     edx,[hMem2]                 ; calculate the size of the include file
    invoke  WriteFile,eax,[hMem2],edx,ecx,0
    test    eax,eax
    jnz     terminate_app
    invoke  StdOut,errmsg4
    jmp     free_memory
    
terminate_app:
    
    invoke  CloseHandle,[hInc]
    
free_memory:

    invoke  FreeLibrary,[hDLL]

free_memory2:

    invoke  VirtualFree,[hMem2],0,MEM_RELEASE
    ret

ENDP


include mainCRTStartup.asm
include StrLen.asm
include StdOut.asm
include GetFileExt.asm
include wsp.asm

